-- Standard Library 05/03/13 --

function qs1(tablename, left, right)
	if type(tablename) == 'table' then
		left = left or 1
		right = right or #tablename
		local i,j,x
		if right-left+1 <= 25 then
			for i=left+1, right do
				x=tablename[i]
				j=i-1
				while j>=left and x<tablename[j] do
					tablename[j+1]=tablename[j]
					j=j-1
				end
				tablename[j+1]=x
			end
		else
			i,j,x = left, right, tablename[math.floor((left+right)/2)]
			local temp
			repeat
				while tablename[i]<x and i < right do
					i = i+1
				end
				while tablename[j]>x and j > left do
					j = j-1
				end
				if (i <= j) then
					temp = tablename[i]
					tablename[i] = tablename[j]
					tablename[j] = temp
					i = i+1
					j = j-1
				end
			until i > j
			if (left < j) then
				qs1(tablename, left, j)
			end
			if (right > i) then
				qs1(tablename, i, right)
			end
		end
	end
end

function qs2(tablename, left, right, argument)
	if type(tablename) == 'table' then
		left = left or 1
		right = right or #tablename
		local i,j,x
		if right-left+1 <= 25 then
			for i=left+1, right do
				x=tablename[i]
				j=i-1
				while j>=left and x[argument] < tablename[j][argument] do
					tablename[j+1]=tablename[j]
					j=j-1
				end
				tablename[j+1]=x
			end
		else
			i,j,x = left, right, tablename[math.floor((left+right)/2)][argument]
			local temp
			repeat
				while tablename[i][argument]<x and i < right do
					i = i+1
				end
				while tablename[j][argument]>x and j > left do
					j = j-1
				end
				if (i <= j) then
					temp = tablename[i]
					tablename[i] = tablename[j]
					tablename[j] = temp
					i = i+1
					j = j-1
				end
			until i > j
			if (left < j) then
				qs2(tablename, left, j, argument)
			end
			if (right > i) then
				qs2(tablename, i, right, argument)
			end
		end
	end
end

function qs3(tablename, left, right)
	if type(tablename) == 'table' then
		left = left or 1
		right = right or #tablename
		local i,j,x
		if right-left+1 <= 25 then
			for i=left+1, right do
				x=tablename[i]
				j=i-1
				while j>=left and x>tablename[j] do
					tablename[j+1]=tablename[j]
					j=j-1
				end
				tablename[j+1]=x
			end
		else
			i,j,x = left, right, tablename[math.floor((left+right)/2)]
			local temp
			repeat
				while tablename[i]>x and i < right do
					i = i+1
				end
				while tablename[j]<x and j > left do
					j = j-1
				end
				if (i <= j) then
					temp = tablename[i]
					tablename[i] = tablename[j]
					tablename[j] = temp
					i = i+1
					j = j-1
				end
			until i > j
			if (left < j) then
				qs3(tablename, left, j)
			end
			if (right > i) then
				qs3(tablename, i, right)
			end
		end
	end
end

function qs4(tablename, left, right, argument)
	if type(tablename) == 'table' then
		left = left or 1
		right = right or #tablename
		local i,j,x
		if right-left+1 <= 25 then
			for i=left+1, right do
				x=tablename[i]
				j=i-1
				while j>=left and x[argument]>tablename[j][argument] do
					tablename[j+1]=tablename[j]
					j=j-1
				end
				tablename[j+1]=x
			end
		else
			i,j,x = left, right, tablename[math.floor((left+right)/2)][argument]
			local temp
			repeat
				while tablename[i][argument]>x and i < right do
					i = i+1
				end
				while tablename[j][argument]<x and j > left do
					j = j-1
				end
				if (i <= j) then
					temp = tablename[i]
					tablename[i] = tablename[j]
					tablename[j] = temp
					i = i+1
					j = j-1
				end
			until i > j
			if (left < j) then
				qs4(tablename, left, j, argument)
			end
			if (right > i) then
				qs4(tablename, i, right, argument)
			end
		end
	end
end


function seq1(tablename,value)
   if type(tablename) == 'table' then
      for i,j in ipairs(tablename) do
         if j == value then
            return i
         end
      end
   end
   return
end

function seq2(tablename,value,argument)
   if type(tablename) == 'table' then
      for i,j in ipairs(tablename) do
         if j[argument] == value then
            return i
         end
      end
   end
   return
end

function bin1(tablename,value)
   if type(tablename) == 'table' then
      local left,right = 1, #tablename
      while left <= right do
         local mid = math.floor((right+left)/2)
         if tablename[mid] == value then
            return mid
         end
         if tablename[mid] > value then
            right = mid-1
         else
            left = mid+1
         end
      end
   end
   return
end

function bin2(tablename,value,argument)
   if type(tablename) == 'table' then
      local left,right = 1, #tablename
      while left <= right do
         local mid = math.floor((right+left)/2)
         if tablename[mid][argument] == value then
            return mid
         end
         if tablename[mid][argument] > value then
            right = mid-1
         else
            left = mid+1
         end
      end
   end
   return
end

function table:find(value,argument) --Working
   if argument then
      return seq2(self,value,argument)
   end
   return seq1(self,value)
end

function table:newsort(argument, order) --Working
	if argument == 'asc' or argument == 'desc' then
		order = argument
		argument = false
	end
	order = order or 'asc'
	if order == 'asc' then
		if argument then
			qs2(self,1,#self,argument)
		else
			qs1(self,1,#self)
		end
	else
		if argument then
			qs4(self,1,#self,argument)
		else
			qs3(self,1,#self)
		end
	end
end

function table:binaryfind(value,argument) --Working
   if argument then
      return bin2(self,value,argument)
   end
   return bin1(self,value)
end

function dropflask()
   dropitems(283,284,285)
end

function depositall()
   say("hi")
   wait(1500,2500)
   npcsay("deposit all")
   wait(300,500)
   npcsay("yes")
   wait(200,300)
end

function opentrade()
   if not tradeopen then
      say("hi")
      wait(1500,2500)
      npcsay("trade")
      wait(600,800)
      updateworld()
   end
end

function sellflasks()
   opentrade()
   if tradeopen then
      for i=283,285 do
         local count = countitem(i)
         while count > 0 do
            sellitems(i,count)
            wait(200,300)
            count = countitem(i)
         end
      end
   end
end

function windowcount(item)
   item = item or "all"
   return wincount(item)
end

function openitem(item, origem, next, index)
   index = index or 0
   next = next or false
   return openitemindex(item, origem, next, index)
end

function wait(time1, time2)
   time2 = time2 or time1
   sleep(time1, time2)
end

function islocation(value)
   value = value or 0
   return isloc(value)
end

function islocationxyz(x,y,z,distance)
   distance= distance or 0
   return _islocationxyz(x,y,z,distance)
end

function moveitems(item, origem, destino, count)
   if destino == nil and count == nil then
      moveitemsb(item, origem, 100)
      return
   end
   if count == nil then
      moveitemsb(item, origem, destino)
      return
   end
   moveitemsa(item, origem, destino, count)
end

function buyitemsupto(itemname, amount, currentamount)
   currentamount = currentamount or itemcount(itemname)
   amount = amount-currentamount
   while amount > 0 do
      buyitems(itemname, amount)
      wait(200,300)
      amount = amount-100
   end
end

function sellitemsupto(itemname, amount, currentamount)
   currentamount = currentamount or itemcount(itemname)
   amount = amount-currentamount
   while amount > 0 do
      sellitems(itemname, amount)
      wait(200,300)
      amount = amount-100
   end
end

function entermachine(item)
  local currentamount = itemcount(item)
  amount = currentamount - 20
  count = 0
  maxtry = 50
  while itemcount(item) > amount and count < maxtry do
      count = count + 1
      if islocationxyz(33268, 31830, 10, 5) then
         if toptileitem(33268, 31830, 10) == 846 then
            useitem(846, 33268, 31830, 10)
            wait(400,600)
         end
   
         useitemon(item, 33268, 31830, 10)
         wait(500,600)

         if(currentamount == itemcount(item)) then
           if toptileitem(33268, 31830, 10) == 842 then
              useitem(842, 33268, 31830, 10)
              wait(400,600)
           end
         else
            currentamount = itemcount(item)
         end
      else
         break
      end
   end
   if toptileitem(33268, 31830, 10) == 842 then
      useitem(842, 33268, 31830, 10)
      wait(400,600)
   end
end

function dropitems(pos,...)
   local items = {...}
   if type(pos) == 'number' then
      table.insert(items,pos)
      pos = 'ground'
   end
   for i,j in ipairs(items) do
      while itemcount(j) > 0 do
         moveitemsb(j,pos,100)
      end
   end
end

function levitate(direction,updown)
   local dir = {x = {n = 0, s = 0, w = -1, e = 1}, y = {n = -1, s = 1, w = 0, e = 0}}
   if direction == 'w' or direction == 'e' or direction == 'n' or direction == 's' then
      local startposz,tries,maxtries = posz,0,math.random(4,6)

      if not updown or (updown ~= 'up' and updown ~= 'down') then
         local toptileid = toptileitem(posx+dir.x[direction],posy+dir.y[direction],posz)

         updown = 'up'
         if toptileid == 0 or itemproperty(toptileid).isUnpassable == true then
            updown = 'down'
         end
      end

      while mp >= 50 and level >= 12 and posz == startposz and tries < maxtries do
         turn(direction)			
         cast('exani hur '..updown)
         wait(1000,1500)
         tries=tries+1
         if posz ~= startz then
            return true
         end
      end
   end
   return false
end

function depotdeposit(bptomove,...)
   lastonto = 0
   local items = {...}
   local _nexti = true
   for i,j in pairs(items) do
      _nexti = true
      while itemcount(items[i]) > 0 and _nexti do
         _nexti = moveitemsonto(items[i], "all", bptomove, 100, lastonto)
         wait(400,500)
      end
   end
end

function itemcount(item, origem, liquid)
   liquid = liquid or -1
   origem = origem or "all"
   return _itemcount(item, origem, liquid)
end

function countitem(item, origem, liquid)
   liquid = liquid or -1
   origem = origem or "all"
   return _itemcount(item, origem, liquid)
end

function higherwindows(name)
   name = name or "all"
   _controlwindows(name, true)
end

function minimizewindows(name)
   name = name or "all"
   _controlwindows(name, false)
end

function maround(range,allfloors,...)
   local names = {...}
   range = range or 7
   allfloors = allfloors or false

   if type(range) == 'string' then
      table.insert(names,range)
      range = 7
   end
   if type(allfloors) == 'string' then
      table.insert(names,allfloors)
      allfloors = false
   end

   local name = ''
   for i,j in pairs(names) do
      name = name..names[i]..';'
   end

   return _maround(range,allfloors,name)
end

function paround(range,allfloors,...)
   local names = {...}
   range = range or 7
   allfloors = allfloors or false

   if type(range) == 'string' then
      table.insert(names,range)
      range = 7
   end
   if type(allfloors) == 'string' then
      table.insert(names,allfloors)
      allfloors = false
   end

   local name = ''
   for i,j in pairs(names) do
      name = name..names[i]..';'
   end

   return _paround(range,allfloors,name)
end

function pickupitems(dir,...)
   local items = {...}
   local dire = {dirs = {'c', 'n', 's', 'w', 'e', 'nw', 'ne', 'sw', 'se'},
		 x = {c = 0, n = 0, s = 0, w = -1, e = 1, nw = -1, ne = 1, sw = -1, se = 1},
		 y = {c = 0, n = -1, s = 1, w = 0, e = 0, nw = -1, ne = -1, sw = 1, se = 1}}

   if not dir or not table.find(dire.dirs,dir) then
      if dir ~= nil then
         table.insert(items,dir)
      end
      dir = 'c'
   end
   
   local pos = {x = posx+dire.x[dir], y = posy+dire.y[dir], z = posz}  
   local topid = toptileitem(pos.x,pos.y,pos.z)
   local id = topid
   local item = itemproperty(topid)
   
   if #items == 0 then
      if topid ~= 0 and item.isTakeable then
         moveitems(topid,ground(pos.x,pos.y,pos.z),'all',100)
      end
   else
      for i,j in pairs(items) do
         if type(j) == 'number' then
            id = j
         else
            id = itemid(j)
         end

         if topid == id and item.isTakeable then
            moveitems(topid,ground(pos.x,pos.y,pos.z),'all',100)
            break
         end
      end
   end
end

function gotolabel(label)
   if type(label) == 'number' then
      _gotolabeln(label)
   else
      _gotolabels(label)
   end
end

function useitem(item, x, y, z)
   x = x or 'all'
   if type(x) == 'number' then
      _useitemxyz(item, x, y, z)
   else
      _useitem(item, x)
   end
end

function useitemon(item, x, y, z)
   if z == nil then
      y = y or 'all'
      useitemonitem(item, x, y)
   else
      _useitemon(item, x, y, z)
   end
end

function say(text, channel)
   if channel == nil then
      _say(text)
   else
      anysay(text, channel)
   end
end

function underattack(type)
   type = type or 'all'
   return _underattack(type)
end

function gold()
   return itemcount(3031) + (itemcount(3035) * 100) + (itemcount(3043) * 10000)
end

function antifurnituretrap(weapontouse)
   weapontouse = weapontouse or 3308 -- machete
   _antifurnituretrap(weapontouse)
end

function getcreatures(filter)
   filter = filter or 'pmfs'
   return _getcreatures(filter)
end

function opensomething(x,y,z,item,holes)
	x,y,z = x or wptx, y or wpty, z or wptz
        item = item or shovel
	holes = holes or {{593,594}, {606, 607}, {608, 609}, {867, 868}}
	reachlocation(x,y,z)
	if x and y and z and math.abs(posx-x) <= 7 and math.abs(posy-y) <= 5 and posz == z then
		local v = 1
		while v <= #holes and not isitemontile(holes[v][1],x,y,z) do
			v = v+1
		end
		if v <= #holes then
			local id = toptileitem(x,y,z)
			while id ~= holes[v][2] do
				if id == holes[v][1] then
					if iscreatureontile(x,y,z) then
						local dir = wheretomove(x,y,z)
						moveitems(99,ground(x,y,z),ground(dir.x,dir.y,z),100)
                                                wait(1400,1600)
					else
						useitemon(item,x,y,z)
	                                        wait(900,1100)
					end
				else
                                        local dir = wheretomove(x,y,z)
					moveitems(id,ground(x,y,z),ground(dir.x,dir.y,z),100)
					wait(500,700)
				end
				id = toptileitem(x,y,z)
			end
			return true
		end
	end
	return false
end

function openpick(x,y,z)
   return opensomething(x,y,z,pick,{{355,394}})
end

function openhole(x,y,z)
   return opensomething(x,y,z,shovel,{{593,594}, {606, 607}, {608, 609}, {867, 868}})
end

function opensand(x,y,z)
   return opensomething(x,y,z,shovel,{{614,615}})
end

function uselever(x,y,z,id)
	x,y,z = x or wptx, y or wpty, z or wptz
	local levers = {2771, 2772}
	if id then
		levers = {id}
	end
	reachlocation(x,y,z)
	if x and y and z and math.abs(posx-x) <= 7 and math.abs(posy-y) <= 5 and posz == z then
		local v = 1
		while v <= #levers and not isitemontile(levers[v],x,y,z) do
			v = v+1
		end
		if v <= #levers then
			local id = toptileitem(x,y,z)
			while isitemontile(levers[v],x,y,z) do
				if id == levers[v] then
					if iscreatureontile(x,y,z) then
						local dir = wheretomove(x,y,z)
						moveitems(99,ground(x,y,z),ground(dir.x,dir.y,z),100)
                                                wait(1400,1600)
					else
						useitem(levers[v],ground(x,y,z))
	                                        wait(500,700)
					end
				else
					local dir = wheretomove(x,y,z)
					moveitems(id,ground(x,y,z),ground(dir.x,dir.y,z),100)
					wait(500,700)
				end
				id = toptileitem(x,y,z)
			end
			return true
		end
	end
	return false
end

function getitems(...)
   local items = {...}

   local item = ''
   for i,j in pairs(items) do
      item = item..items[i]..';'
   end

   return _getitems(item)
end

function shootarearune(rune, amtmobs, ...)
   local names = {...}
   amtmobs = amtmobs or 1
   local name = ''
   for i,j in pairs(names) do
      name = name..names[i]..';'
   end
   
   return _shootarearune(rune,amtmobs,name)
end

function screenshot(name)
   name = name or ""
   _screenshot(name)
end

function tilereachable(x, y, z, update)
   if type(update) == 'nil' then
      update = true
   end
   return _tilereachable(x,y,z,update)
end

function tileshootable(x, y, z, update)
   if type(update) == 'nil' then
      update = true
   end
   return _tileshootable(x,y,z,update)
end

function tileiswalkable(x, y, z, update)
   if type(update) == 'nil' then
      update = true
   end
   return _tileiswalkable(x,y,z,update)
end

function clienttexthotkey(text, usetype)
   usetype = usetype or "all"
   return _clienttexthotkey(text, usetype)
end

function clientitemhotkey(text, usetype)
   usetype = usetype or "all"
   return _clientitemhotkey(text, usetype)
end

function maroundshootable(range,...)
   local names = {...}
   range = range or 7

   local name = ''
   for i,j in pairs(names) do
      name = name..names[i]..';'
   end

   return _maroundshootable(range,name)
end

function maroundreachable(range,...)
   local names = {...}
   range = range or 7

   local name = ''
   for i,j in pairs(names) do
      name = name..names[i]..';'
   end

   return _maroundreachable(range,name)
end

function withdrawint(value, integer)
   integer = integer or 1000
   return _withdrawint(value, integer)
end